// Not copyrighted - public domain.
//
// This sample serializer implementation was generated by CodeSynthesis XSD/e,
// an XML Schema to C++ data binding compiler for embedded systems. You may
// use it in your programs without any restrictions.
//

#include "test-simpl.hxx"

#include <stdio.h>

struct writer: ::xml_schema::writer
{
  virtual bool
  write (const char* s, size_t n)
  {
    return fwrite (s, n, 1, stdout) == 1;
  }

  virtual bool
  flush ()
  {
    return fflush (stdout) == 0;
  }
};

int
main ()
{
  // Instantiate individual serializers.
  //
  ::test::type_simpl type_s;
  ::xml_schema::int_simpl int_s;

  // Connect the serializers together.
  //
  type_s.serializers (int_s);

  // Serialize the XML document.
  //
  writer w;
  ::xml_schema::serializer_error e;

  do
  {
    ::xml_schema::document_simpl doc_s (
      type_s,
      "test",
      "root");

    if (e = doc_s._error ())
      break;

    type_s.pre ();

    if (e = type_s._error ())
      break;

    doc_s.serialize (w);

    if (e = doc_s._error ())
      break;

    type_s.post ();

    e = type_s._error ();
  }
  while (false);

  // Handle errors.
  //
  if (e)
  {
    switch (e.type ())
    {
      case ::xml_schema::serializer_error::sys:
      {
        fprintf (stderr, "%s\n", e.sys_text ());
        break;
      }
      case ::xml_schema::serializer_error::xml:
      {
        fprintf (stderr, "%s\n", e.xml_text ());
        break;
      }
      case ::xml_schema::serializer_error::app:
      {
        fprintf (stderr, "application error %d\n", e.app_code ());
        break;
      }
      default:
      {
        break;
      }
    }

    return 1;
  }

  return 0;
}

